## hatari 2.0.0+dfsg

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 2.6 FATAL_ERROR)

if(POLICY CMP0026)
	# Should be removed if cmake_minimum_required >= 2.8.8
	cmake_policy(SET CMP0026 OLD)
endif(POLICY CMP0026)

project(Hatari C)

SET(APP_NAME "Hatari")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")

include(CheckIncludeFiles)
include(CheckFunctionExists)
include(CheckStructHasMember)
include(CheckCCompilerFlag)
include(DistClean)

# Set build type to "Release" if user did not specify any build type yet
# Other possible values: Debug, Release, RelWithDebInfo and MinSizeRel
if(NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE Release)
endif(NOT CMAKE_BUILD_TYPE)

# set(CMAKE_VERBOSE_MAKEFILE 1)

# ##########################
# Conditional build features
# ##########################

set(ENABLE_SDL2 1
    CACHE BOOL "Enable building with libSDL2 instead of v1.2")
set(ENABLE_DSP_EMU 1
    CACHE BOOL "Enable DSP 56k emulator for Falcon mode")
set(ENABLE_TRACING 1
    CACHE BOOL "Enable tracing messages for debugging")
set(ENABLE_SMALL_MEM 0
    CACHE BOOL "Enable to use less memory - at the expense of emulation speed")
set(ENABLE_WINUAE_CPU 1
    CACHE BOOL "Enable WinUAE CPU core")

# Run-time checks with GCC "mudflap" etc features:
# - stack protection
# - checking of pointer accesses
#
# Before running CMake, install "mudflap" library development package
# (libmudflap0-4.4-dev in Debian Squeeze and libmudflap-devel in Fedora).
#
# After this you can configure Hatari with Mudflap:
#   cd build; make clean; cmake -D ENABLE_MUDFLAP:BOOL=1 -D ..
# If everything's fine, CMake output should include:
#   Performing Test MUDFLAP_AVAILABLE - Success"
#
# After (re-)building Hatari, run it with something like this:
#   MUDFLAP_OPTIONS="-viol-gdb" src/hatari --sound off --mic off
# (sound&mic are disabled because threading doesn't work well with Mudflap)
#
# For more info:
#   http://gcc.gnu.org/wiki/Mudflap_Pointer_Debugging
#
set(CMAKE_REQUIRED_LIBRARIES "mudflap")
CHECK_C_COMPILER_FLAG("-fmudflapth" MUDFLAP_AVAILABLE)
set(CMAKE_REQUIRED_LIBRARIES "")
if(MUDFLAP_AVAILABLE)
	set(ENABLE_MUDFLAP 0
	    CACHE BOOL "Enable GCC run-time stack/pointer debugging - with huge slowdown")
endif(MUDFLAP_AVAILABLE)

if(APPLE)
	set(ENABLE_OSX_BUNDLE 1
	    CACHE BOOL "Built Hatari as Mac OS X application bundle")
	# set(CMAKE_OSX_ARCHITECTURES "i386" CACHE STRING "Target architectures" FORCE)
	# set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.6.sdk" CACHE STRING "10.6 SDK" FORCE)
	# set(CMAKE_OSX_DEPLOYMENT_TARGET "10.5" CACHE STRING "Target Min 10.5" FORCE)
	set(ADDITIONAL_INCLUDES ${FRAMEWORKS})
	set_source_files_properties(${FRAMEWORKS} PROPERTIES MACOSX_PACKAGE_LOCATION Frameworks)
else()
	set(ENABLE_OSX_BUNDLE 0
	    CACHE BOOL "Built Hatari as Mac OS X application bundle")
endif(APPLE)

# ####################
# Check for libraries:
# ####################

if(ENABLE_SDL2)
	find_package(SDL2)
	#if(NOT SDL2_FOUND)
	#	message(FATAL_ERROR "SDL2 library not found!")
	#endif(NOT SDL2_FOUND)
	set(SDL_INCLUDE_DIR ${SDL2_INCLUDE_DIR})
	set(SDL_LIBRARY ${SDL2_LIBRARY})
	set(SDLMAIN_LIBRARY ${SDL2MAIN_LIBRARY})
endif(ENABLE_SDL2)

if(NOT SDL2_FOUND)
	find_package(SDL)
	if(NOT SDL_FOUND)
		message(FATAL_ERROR "SDL library not found!")
	endif(NOT SDL_FOUND)
endif(NOT SDL2_FOUND)

find_package(Math)

find_package(Readline)
if(READLINE_FOUND)
	set(HAVE_LIBREADLINE 1)
endif(READLINE_FOUND)

find_package(ZLIB)
if(ZLIB_FOUND)
	set(HAVE_LIBZ 1)
	set(HAVE_ZLIB_H 1)
endif(ZLIB_FOUND)

find_package(PNG)
if(PNG_FOUND)
	set(HAVE_LIBPNG 1)
endif(PNG_FOUND)

if (NOT ENABLE_OSX_BUNDLE)
	find_package(X11)
	if(X11_FOUND)
		set(HAVE_X11 1)
	endif(X11_FOUND)
endif()

find_package(PortAudio)
if(PORTAUDIO_FOUND)
	set(HAVE_PORTAUDIO 1)
endif(PORTAUDIO_FOUND)

find_package(CapsImage)
if(CAPSIMAGE_FOUND)
	set(HAVE_CAPSIMAGE 1)
endif(CAPSIMAGE_FOUND)

find_package(Udev)
if(UDEV_FOUND)
	set(HAVE_UDEV 1)
endif(UDEV_FOUND)

# ################
# CPP Definitions:
# ################

# Test for large file support:
execute_process(COMMAND getconf LFS_CFLAGS
                OUTPUT_VARIABLE DETECTED_LFS_CFLAGS
                ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
if(DETECTED_LFS_CFLAGS)
	add_definitions(${DETECTED_LFS_CFLAGS})
	# message(STATUS "Large filesystem flags: ${DETECTED_LFS_CFLAGS}")
endif(DETECTED_LFS_CFLAGS)

# Additional CFLAGS suggested by the SDL library:
if(SDL2_FOUND)
	add_definitions(-DWITH_SDL2)
	execute_process(COMMAND pkg-config --cflags-only-other sdl2
			OUTPUT_VARIABLE DETECTED_SDL_CFLAGS
			ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
else(SDL2_FOUND)
	execute_process(COMMAND pkg-config --cflags-only-other sdl
			OUTPUT_VARIABLE DETECTED_SDL_CFLAGS
			ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
endif(SDL2_FOUND)
if(DETECTED_SDL_CFLAGS)
	add_definitions(${DETECTED_SDL_CFLAGS})
	# message(STATUS "Additional CFLAGS of SDL: ${DETECTED_SDL_CFLAGS}")
endif(DETECTED_SDL_CFLAGS)

if(ENABLE_OSX_BUNDLE)
	# Use OSX native alert windows
	add_definitions(-DALERT_HOOKS=1)
	if(SDL2_FOUND)
		# We still want to use our SDLMain.m with SDL2
		add_definitions(-DSDL_MAIN_NEEDED=1)
	endif(SDL2_FOUND)
endif(ENABLE_OSX_BUNDLE)

# ###########################
# Check for optional headers:
# ###########################

check_include_files(termios.h HAVE_TERMIOS_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(${SDL_INCLUDE_DIR}/SDL_config.h HAVE_SDL_CONFIG_H)
check_include_files(sys/time.h HAVE_SYS_TIME_H)
check_include_files(sys/times.h HAVE_SYS_TIMES_H)
check_include_files(utime.h HAVE_UTIME_H)
check_include_files(sys/utime.h HAVE_SYS_UTIME_H)
check_include_files("sys/socket.h;sys/un.h" HAVE_UNIX_DOMAIN_SOCKETS)

# #############################
# Check for optional functions:
# #############################

check_function_exists(cfmakeraw HAVE_CFMAKERAW)
check_function_exists(setenv HAVE_SETENV)
check_function_exists(select HAVE_SELECT)
check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)
check_function_exists(nanosleep HAVE_NANOSLEEP)
check_function_exists(alphasort HAVE_ALPHASORT)
check_function_exists(scandir HAVE_SCANDIR)
check_function_exists(statvfs HAVE_STATVFS)
check_function_exists(fseeko HAVE_FSEEKO)
check_function_exists(ftello HAVE_FTELLO)
check_function_exists(flock HAVE_FLOCK)
check_function_exists(strlcpy HAVE_LIBC_STRLCPY)
check_struct_has_member("struct dirent" d_type dirent.h HAVE_DIRENT_D_TYPE)

# #############
# Other CFLAGS:
# #############

# GCC pointer debugging, huge run-time slowdown
if(ENABLE_MUDFLAP)
	# SDL mixer threads so have to use threaded mudflap version
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fstack-protector-all -fmudflapth")
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fmudflapth -lmudflap")
endif(ENABLE_MUDFLAP)

# Warning flags:
if(CMAKE_COMPILER_IS_GNUCC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcast-qual -Wbad-function-cast -Wpointer-arith")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes -Wstrict-prototypes")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wwrite-strings -Wsign-compare")
	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wextra -Wno-unused-parameter -Wno-empty-body")
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat-security")
	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow -D_FORTIFY_SOURCE=2 -Werror")
endif(CMAKE_COMPILER_IS_GNUCC)

# Building Hatari w/o optimization is no fun...
IF (CMAKE_BUILD_TYPE STREQUAL "Debug")
	set(CMAKE_C_FLAGS "-O ${CMAKE_C_FLAGS}")
ENDIF (CMAKE_BUILD_TYPE STREQUAL "Debug")

# ####################
# Paths configuration:
# ####################

if(NOT BINDIR)
	set(BINDIR bin)
endif()

if(NOT DATADIR)
	set(DATADIR share/hatari)
endif()

if(NOT BIN2DATADIR)
	if(WIN32)
		set(BIN2DATADIR "."
		    CACHE STRING "Relative path from bindir to datadir")
	elseif(ENABLE_OSX_BUNDLE)
		set(BIN2DATADIR "../Resources"
		    CACHE STRING "Relative path from bindir to datadir")
	else()
		set(BIN2DATADIR "../share/hatari"
		    CACHE STRING "Relative path from bindir to datadir")
	endif(WIN32)
	mark_as_advanced(BIN2DATADIR)
endif()

if(NOT MANDIR)
	set(MANDIR share/man/man1)
endif()

if(NOT DOCDIR)
	set(DOCDIR share/doc/hatari)
endif()

if(NOT ETCDIR)
	if(WIN32)
		set(ETCDIR .)
	else()
		set(ETCDIR /etc)
	endif()
endif()

if(NOT ICONDIR)
	set(ICONDIR share/icons/hicolor)
endif()

if(ENABLE_OSX_BUNDLE)
	# put the config files in the app's bundle
	add_definitions(-DCONFDIR=\"../Resources\")
else()
	add_definitions(-DCONFDIR=\"${ETCDIR}\")
endif()

# #########################################
# Create config.h and recurse into subdirs:
# #########################################

configure_file(${CMAKE_SOURCE_DIR}/cmake/config-cmake.h
		${CMAKE_BINARY_DIR}/config.h)

add_subdirectory(src)
add_subdirectory(doc)
add_subdirectory(tools)

include(FindPythonInterp)
if(PYTHONINTERP_FOUND)
	add_subdirectory(python-ui)
endif(PYTHONINTERP_FOUND)

if(UNIX AND NOT ENABLE_OSX_BUNDLE)
	add_subdirectory(share)
endif()

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_SOURCE_DIR}/cmake/Uninstall.cmake)


# ###################################################################
# Print a summary of the optional libraries with a short explanation:
# ###################################################################

message( "
Libraries summary :
-------------------
")

if(SDL2_FOUND)
  message("  - sdl :\tusing SDL2 v${SDL2_VERSION_STRING}")
else()
  if(SDL_VERSION_STRING)
    message("  - sdl :\tusing SDL v${SDL_VERSION_STRING}")
  else()
    message("  - sdl :\tusing SDL1")
  endif(SDL_VERSION_STRING)
endif(SDL2_FOUND)

if(READLINE_FOUND)
  message( "  - readline :\tfound, enables history/completion in the debugger" )
else()
  message( "  - readline :\tnot found, install it to enable debugger history/completion" )
endif(READLINE_FOUND)

if(ZLIB_FOUND)
  message( "  - zlib :\tfound, allows to use zip/gz files directly" )
else()
  message( "  - zlib :\tnot found, install it to use zip/gz files" )
endif(ZLIB_FOUND)

if(PNG_FOUND)
  message( "  - png :\tfound, allows to compress screenshot/avi files using png" )
else()
  message( "  - png :\tnot found, install it to compress screenshot/avi files using png" )
endif(PNG_FOUND)

if(PORTAUDIO_FOUND)
  message( "  - portaudio :\tfound, enables the microphone input in Falcon mode" )
else()
  message( "  - portaudio :\tnot found, install it to enable the Falcon microphone input" )
endif(PORTAUDIO_FOUND)

if(CAPSIMAGE_FOUND)
  message( "  - capsimage :\tv${CAPSIMAGE_VERSION} found, allow to use .IPF, .RAW and .CTR disk images" )
else()
  message( "  - capsimage :\tv${CAPSIMAGE_VERSION} not found, install it to use .IPF, .RAW and .CTR disk images" )
endif(CAPSIMAGE_FOUND)

if(UDEV_FOUND)
  message( "  - udev :\tfound, required for media change detection in NatFeats SCSI" )
  message( "          \tdevices on udev-based systems (Linux)" )
else()
  if(UNIX AND NOT APPLE AND NOT CYGWIN)
    message( "  - udev :\tnot found, install it to enable media change detection in" )
    message( "          \tNatFeats SCSI devices on udev-based systems (Linux)" )
  endif()
endif(UDEV_FOUND)

if(NOT HAVE_SYS_TIMES_H)
  message("\n  Note: times() function is missing (sys/times.h is not available)")
  message("        ==> using inaccurate SDL_GetTicks() instead")
endif()

message( "" )

=== share/CMakeLists.txt ===

foreach(size 32x32 48x48 64x64 128x128 256x256)
	install(FILES icons/hicolor/${size}/apps/hatari.png
		DESTINATION ${ICONDIR}/${size}/apps)
	install(FILES icons/hicolor/${size}/mimetypes/application-x-st-disk-image.png
		DESTINATION ${ICONDIR}/${size}/mimetypes)
	foreach(type vnd.msa vnd.fastcopy x-stx)
		install(CODE "execute_process(COMMAND ln -sf application-x-st-disk-image.png
				${CMAKE_INSTALL_PREFIX}/${ICONDIR}/${size}/mimetypes/application-${type}-disk-image.png)
				")
	endforeach()
endforeach()

install(FILES icons/hicolor/scalable/apps/hatari.svg
	DESTINATION ${ICONDIR}/scalable/apps)
install(FILES icons/hicolor/scalable/mimetypes/application-x-st-disk-image.svg
	DESTINATION ${ICONDIR}/scalable/mimetypes)
foreach(type vnd.msa vnd.fastcopy x-stx)
	install(CODE "execute_process(COMMAND ln -sf application-x-st-disk-image.svg
			${CMAKE_INSTALL_PREFIX}/${ICONDIR}/scalable/mimetypes/application-${type}-disk-image.svg)
			")
endforeach()
install(FILES mime/packages/hatari.xml DESTINATION share/mime/packages)

install(FILES applications/hatari.desktop DESTINATION share/applications)

=== src/CMakeLists.txt ===

set(SOURCES
	acia.c audio.c avi_record.c bios.c blitter.c cart.c cfgopts.c
	clocks_timings.c configuration.c options.c change.c control.c
	cycInt.c cycles.c dialog.c dmaSnd.c fdc.c file.c floppy.c
	floppy_ipf.c floppy_stx.c gemdos.c hd6301_cpu.c hdc.c ide.c ikbd.c
	ioMem.c ioMemTabST.c ioMemTabSTE.c ioMemTabTT.c ioMemTabFalcon.c joy.c
	keymap.c m68000.c main.c midi.c memorySnapShot.c mfp.c nf_scsidrv.c
	paths.c  psg.c printer.c resolution.c rs232.c reset.c rtc.c
	scandir.c stMemory.c screen.c screenConvert.c screenSnapShot.c
	shortcut.c sound.c spec512.c statusbar.c str.c tos.c utils.c
	vdi.c video.c wavFormat.c xbios.c ymFormat.c)

# Disk image code is shared with the hmsa tool, so we put it into a library:
add_library(Floppy createBlankImage.c dim.c msa.c st.c zip.c)

# When building for OSX, define specific sources for gui and ressources
if(ENABLE_OSX_BUNDLE)
	set(GUIOSX_SOURCES
	    gui-osx/AlertHooks.m gui-osx/PrefsController.m gui-osx/Shared.m
	    gui-osx/CreateFloppyController.m gui-osx/SDLMain.m)
	set_source_files_properties(${GUIOSX_SOURCES} PROPERTIES LANGUAGE C)
	set(GUIOSX_RSRCS
	    gui-osx/Hatari.icns gui-osx/en.lproj gui-osx/fr.lproj)
	set(GUIOSX_DOCS
	    ${CMAKE_SOURCE_DIR}/doc/manual.html ${CMAKE_SOURCE_DIR}/doc/images
	    ${CMAKE_SOURCE_DIR}/doc/compatibility.html)
	# these are the OS X Interface Builder Files
	set (HATARI_XIBS en.lproj/SDLMain fr.lproj/SDLMain)
endif(ENABLE_OSX_BUNDLE)

# When building for Windows, define specific sources for gui and resources
# and set the subsystem of the resulting .exe to "windows GUI" instead of "console"
if(WIN32)
	set(GUIWIN_SOURCES gui-win/opencon.c)
	set(GUIWIN_RES gui-win/hatari-winicon.rc)
	set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -mwindows")
endif(WIN32)

if(ENABLE_WINUAE_CPU)
	set(CPUDIR cpu)
else()
	set(CPUDIR uae-cpu)
endif(ENABLE_WINUAE_CPU)

include_directories(${CMAKE_BINARY_DIR} ${SDL_INCLUDE_DIR} ${CPUDIR}
		    includes debug falcon)

if(ZLIB_FOUND)
	include_directories(${ZLIB_INCLUDE_DIR})
	set(SOURCES ${SOURCES} unzip.c)
endif(ZLIB_FOUND)

if(PNG_FOUND)
	include_directories(${PNG_INCLUDE_DIR})
endif(PNG_FOUND)

if(X11_FOUND)
	include_directories(${X11_INCLUDE_DIR})
endif(X11_FOUND)


link_directories(${CMAKE_CURRENT_BINARY_DIR}/debug
		 ${CMAKE_CURRENT_BINARY_DIR}/falcon
		 ${CMAKE_CURRENT_BINARY_DIR}/gui-sdl
		 ${CMAKE_CURRENT_BINARY_DIR}/${CPUDIR})

add_subdirectory(debug)
add_subdirectory(falcon)
add_subdirectory(gui-sdl)
add_subdirectory(${CPUDIR})

# When building for OSX, add specific sources
if(ENABLE_OSX_BUNDLE)
	#find_library(SDL_FRAMEWORK SDL ${ADD_FRAMEWOK_PATH})
	set(ADDITIONAL_INCLUDES ${FRAMEWORKS})
	set_source_files_properties(${FRAMEWORKS} PROPERTIES MACOSX_PACKAGE_LOCATION Frameworks)
	add_executable(hatari MACOSX_BUNDLE ${GUIOSX_RSRCS} ${GUIOSX_DOCS} ${SOURCES} ${GUIOSX_SOURCES} ${FRAMEWORKS})
	set_target_properties(hatari PROPERTIES MACOSX_BUNDLE_INFO_PLIST
			      ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/Info-Hatari.plist)
	set(MACOSX_BUNDLE_ICON_FILE Hatari.icns)
	if(CMAKE_GENERATOR MATCHES "Xcode")
		set(BUNDLE_CONTENTS ${CMAKE_CURRENT_BINARY_DIR}/\${CONFIGURATION}/Hatari.app/Contents)
	else()
		set(BUNDLE_CONTENTS ${CMAKE_CURRENT_BINARY_DIR}/Hatari.app/Contents)
	endif()
	# Create Hatari.app bundle
	add_custom_target(osx_bundle_dirs
			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources
			#COMMAND mkdir -p ${BUNDLE_CONTENTS}/Frameworks
			COMMAND mkdir -p ${BUNDLE_CONTENTS}/MacOS
			COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${MACOSX_BUNDLE_ICON_FILE}
				   ${BUNDLE_CONTENTS}/Resources/${MACOSX_BUNDLE_ICON_FILE}
			# Copy Localized .nib to Bundle
			COMMAND cp -R ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/*.lproj ${BUNDLE_CONTENTS}/Resources/
			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/en.lproj/HatariHelp
			COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/en.lproj/HatariHelp/
			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/fr.lproj/HatariHelp
			COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/fr.lproj/HatariHelp/
	)
	add_dependencies(hatari osx_bundle_dirs)
	set_source_files_properties(${GUIOSX_RSRCS} PROPERTIES
				    MACOSX_PACKAGE_LOCATION Resources)
	set_source_files_properties(${GUIOSX_DOCS} PROPERTIES
				    MACOSX_PACKAGE_LOCATION Resources/en.lproj/HatariHelp)

	#find ibtool
	find_program(IBTOOL ibtool HINTS "/usr/bin" "${OSX_DEVELOPER_ROOT}/usr/bin")
	if (${IBTOOL} STREQUAL "IBTOOL-NOTFOUND")
		message(SEND_ERROR "ibtool can not be found and is needed to compile the .xib files.
			It should have been installed with the Apple developer tools. The default
			system paths were searched in addition to ${OSX_DEVELOPER_ROOT}/usr/bin")
	endif()
	# Compile the .xib files using the 'ibtool' program with the destination being the app package
	foreach(xib ${HATARI_XIBS})
		add_custom_command (TARGET hatari POST_BUILD
			COMMAND ${IBTOOL} --errors --warnings --notices --output-format human-readable-text
				--compile ${BUNDLE_CONTENTS}/Resources/${xib}.nib ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${xib}.xib
			COMMENT "Compiling ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${xib}.xib")
	endforeach()

# When building for Windows, add specific sources + method to compile .rc files
elseif(WIN32)
	# Set a default rc compiler if it was not defined yet
	if(NOT CMAKE_RC_COMPILER)
		set(CMAKE_RC_COMPILER windres)
	endif(NOT CMAKE_RC_COMPILER)
	ENABLE_LANGUAGE(RC)
	set(CMAKE_RC_COMPILE_OBJECT "<CMAKE_RC_COMPILER> -Ocoff -o <OBJECT> <SOURCE>")
	set_source_files_properties(${GUIWIN_RES} PROPERTIES LANGUAGE RC)
	add_executable(hatari ${GUIWIN_RES} ${SOURCES} ${GUIWIN_SOURCES})

# Other targets, use default sources
else()
	add_executable(hatari ${SOURCES})
endif(ENABLE_OSX_BUNDLE)

target_link_libraries(hatari Falcon UaeCpu GuiSdl Floppy Debug ${SDL_LIBRARY})

if(MATH_FOUND AND NOT APPLE)
	target_link_libraries(hatari ${MATH_LIBRARY})
endif()

if(SDLMAIN_LIBRARY)
	target_link_libraries(hatari ${SDLMAIN_LIBRARY})
endif(SDLMAIN_LIBRARY)

if(READLINE_FOUND)
	target_link_libraries(hatari ${READLINE_LIBRARY})
endif(READLINE_FOUND)

if(ZLIB_FOUND)
	target_link_libraries(hatari ${ZLIB_LIBRARY})
endif(ZLIB_FOUND)

if(PNG_FOUND)
	target_link_libraries(hatari ${PNG_LIBRARY})
endif(PNG_FOUND)

if(X11_FOUND)
	target_link_libraries(hatari ${X11_LIBRARIES})
endif(X11_FOUND)

if(PORTAUDIO_FOUND)
	target_link_libraries(hatari ${PORTAUDIO_LIBRARY})
endif(PORTAUDIO_FOUND)

if(CAPSIMAGE_FOUND)
	target_link_libraries(hatari ${CAPSIMAGE_LIBRARY})
endif(CAPSIMAGE_FOUND)

if(UDEV_FOUND)
	target_link_libraries(hatari ${UDEV_LIBRARY})
endif(UDEV_FOUND)

if(WIN32)
	# Needed for socket() on Windows
	target_link_libraries(hatari ws2_32)
endif(WIN32)


if(ENABLE_OSX_BUNDLE)
	install(TARGETS hatari BUNDLE DESTINATION /Applications)
else()
	install(TARGETS hatari RUNTIME DESTINATION ${BINDIR})
	install(FILES hatari-icon.bmp DESTINATION ${DATADIR})
	file(GLOB TOS_IMG_FILE tos.img)
	if(TOS_IMG_FILE)
		install(FILES tos.img DESTINATION ${DATADIR})
	endif(TOS_IMG_FILE)
endif(ENABLE_OSX_BUNDLE)

=== src/cpu/CMakeLists.txt ===

include_directories(. ../.. ../includes ${SDL_INCLUDE_DIR}) 

# The sources generated by gencpu:
set(CPUEMU_SRCS cpustbl.c cpuemu_0.c cpuemu_11.c cpuemu_13.c
		cpuemu_20.c cpuemu_21.c cpuemu_22.c cpuemu_23.c cpuemu_24.c
		cpuemu_31.c cpuemu_32.c cpuemu_33.c cpuemu_40.c cpuemu_50.c)

# Unfortunately we've got to specify the rules for the generated files twice,
# once for cross compiling (with calling the host cc directly) and once
# for native compiling so that the rules also work for non-Unix environments...
if(CMAKE_CROSSCOMPILING)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/build68k
		COMMAND cc -I${CMAKE_CURRENT_SOURCE_DIR}
			   ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c
			   ${CMAKE_CURRENT_SOURCE_DIR}/writelog.c
			   -o ${CMAKE_CURRENT_BINARY_DIR}/build68k
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c)

	add_custom_command(OUTPUT cpudefs.c
		COMMAND ./build68k < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/table68k
			${CMAKE_CURRENT_BINARY_DIR}/build68k)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		COMMAND cc -I${CMAKE_CURRENT_SOURCE_DIR}
			   cpudefs.c ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			   ${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c
			   -o ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c cpudefs.c)

	add_custom_command(OUTPUT ${CPUEMU_SRCS}
		COMMAND ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gencpu)

else()	# Rules for normal build follow

	add_executable(build68k build68k.c writelog.c)

	get_target_property(BUILD68K_EXE build68k LOCATION)
	add_custom_command(OUTPUT cpudefs.c
		COMMAND ${BUILD68K_EXE} < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS table68k build68k)

	add_executable(gencpu gencpu.c readcpu.c cpudefs.c)

	get_target_property(GENCPU_EXE gencpu LOCATION)
	add_custom_command(OUTPUT ${CPUEMU_SRCS}
		COMMAND ${GENCPU_EXE}  DEPENDS gencpu)

endif(CMAKE_CROSSCOMPILING)


# Generated cpuemu_xx.c contains a lot of warnings we don't really care about...
set(CPUEMU_CFLAGS "-Wno-sign-compare -Wno-shadow -Wno-unused-variable")
if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.6)
	set (CPUEMU_CFLAGS "${CPUEMU_CFLAGS} -Wno-unused-but-set-variable")
endif()

if(CMAKE_COMPILER_IS_GNUCC)
	# Silence some warnings for the autogenerated sources
	set_source_files_properties(${CPUEMU_SRCS} cpudefs.c
		PROPERTIES COMPILE_FLAGS ${CPUEMU_CFLAGS})

	# For the other files, hide some harmless warnings, too (since we
	# try to keep the files in sync with WinUAE, it's hard to fix them)
	if (1)
		set(CPUMAIN_CFLAGS "-Wno-unused-variable -Wno-unused-function -Wno-unused-label")
		if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.6)
			set (CPUMAIN_CFLAGS "${CPUMAIN_CFLAGS} -Wno-unused-but-set-variable")
		endif()
		# The remaining warnings can be hidden for the release:
		# set next if to "1" instead of "0"
		if (0)
			set(CPUMAIN_CFLAGS "${CPUMAIN_CFLAGS} -Wno-sign-compare -Wno-maybe-uninitialized -Wno-bad-function-cast")
		endif()
		set_source_files_properties(newcpu.c newcpu_common.c cpummu.c fpp.c memory.c
			PROPERTIES COMPILE_FLAGS ${CPUMAIN_CFLAGS})
	endif()

endif(CMAKE_COMPILER_IS_GNUCC)

add_library(UaeCpu ${CPUEMU_SRCS} cpudefs.c cpummu.c cpummu030.c custom.c
		   debug.c events.c hatari-glue.c memory.c newcpu_common.c
		   readcpu.c fpp.c newcpu.c writelog.c)

=== src/gui-sdl/CMakeLists.txt ===

include_directories(. ../.. ../debug ../includes ${SDL_INCLUDE_DIR}) 

if(CMAKE_COMPILER_IS_GNUCC)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-write-strings")
endif(CMAKE_COMPILER_IS_GNUCC)

add_library(GuiSdl
	dlgAbout.c dlgAlert.c dlgCpu.c dlgDevice.c dlgFileSelect.c dlgFloppy.c
	dlgHalt.c dlgHardDisk.c dlgJoystick.c dlgKeyboard.c dlgMain.c
	dlgMemory.c dlgNewDisk.c dlgRom.c dlgScreen.c dlgSound.c dlgSystem.c
	sdlgui.c
	)

=== debian/changelog ===
hatari (2.0.0+dfsg-3) unstable; urgency=medium

  * Add patch 08-add-aarch64-support, fixing FTBFS on aarch64.
  * Add patch 09-do-not-bail-on-unknown-cpu, fixing FTBFS on s390x.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 15 Jan 2017 09:43:19 +0100

hatari (2.0.0+dfsg-2) unstable; urgency=medium

  * Add patch 07-add-mips-support, fixing FTBFS on mips.
    Thanks to Radovan Birdic. (Closes: #851267)

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 15 Jan 2017 01:30:03 +0100

hatari (2.0.0+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Update copyright years.
  * Build-Depend on libsdl2-dev.
  * Bump Standards-Version, no changes needed.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Tue, 10 Jan 2017 21:22:51 +0100

=== debian/control ===
Source: hatari
Section: otherosfs
Priority: optional
Maintainer: Teemu Hukkanen <tjhukkan@iki.fi>
Build-Depends: cmake,
               debhelper (>= 9),
               dh-python,
               libpng-dev,
               libreadline-dev,
               libsdl2-dev,
               portaudio19-dev,
               python,
               zlib1g-dev
Standards-Version: 3.9.8
Homepage: http://hatari.tuxfamily.org/

Package: hatari
Architecture: any
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Recommends: binfmt-support
Suggests: dosfstools, mtools, unzip
Description: Emulator for the Atari ST, STE, TT, and Falcon computers
 Hatari is an emulator for the Atari ST line of computers.
 .
 The Atari ST was a 16/32 bit computer system which was first released by
 Atari in 1985. Using the Motorola 68000 CPU, it was a very popular computer
 having quite a lot of CPU power at that time.
 .
 Unlike many other Atari ST emulators which try to give you a good environment
 for running GEM applications, Hatari tries to emulate the hardware of a ST as
 close as possible so that it is able to run most of the old ST games and
 demos.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS=1
include /usr/share/dpkg/buildflags.mk
# FIXME: Check if cmake can take flags directly from environment
#        This would make the dh_auto_configure incantation much simpler

LDFLAGS += -Wl,--as-needed
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

export BUILD_DATE = $(shell LC_ALL=C date -u --date="`dpkg-parsechangelog -SDate`" +'%b %e %Y %H:%M:%S')
#CFLAGS += -DBUILD_DATE='$(BUILD_DATE)'
#CXXFLAGS += -DBUILD_DATE='$(BUILD_DATE)'
CFLAGS += -DBUILD_DATE="\"foo\""
CXXFLAGS += -DBUILD_DATE="\"bar\""

%:
	dh $@ --buildsystem=cmake --builddirectory=build --with=python2

override_dh_auto_configure:
	 dh_auto_configure -O--buildsystem=cmake \
	   -O--builddirectory=build \
	   -- \
	   -DCMAKE_COLOR_MAKEFILE:BOOL=0 \
	   -DCMAKE_C_FLAGS:STRING="$(CFLAGS)" \
	   -DCMAKE_CXX_FLAGS:STRING="$(CXXFLAGS)" \
	   -DCMAKE_LINK_FLAGS:STRING="$(LDFLAGS)"
	 dh_auto_configure -O--buildsystem=cmake \
	   -O--builddirectory=build-winuae \
	   -- \
	   -DENABLE_WINUAE_CPU:BOOL=1 \
	   -DCMAKE_COLOR_MAKEFILE:BOOL=0 \
	   -DCMAKE_SKIP_RPATH:BOOL=1 \
	   -DCMAKE_C_FLAGS:STRING="$(CFLAGS)" \
	   -DCMAKE_CXX_FLAGS:STRING="$(CXXFLAGS)" \
	   -DCMAKE_LINK_FLAGS:STRING="$(LDFLAGS)"
	#dh_auto_configure -O--buildsystem=cmake \
	#  -O--builddirectory=build \
	#  -- \
	#  -DCMAKE_COLOR_MAKEFILE:BOOL=0
	#dh_auto_configure -O--buildsystem=cmake \
	#  -O--builddirectory=build-winuae \
	#  -- \
	#  -DENABLE_WINUAE_CPU:BOOL=1 \
	#  -DCMAKE_COLOR_MAKEFILE:BOOL=0 \
	#  -DCMAKE_SKIP_RPATH:BOOL=1

override_dh_auto_build:
	dh_auto_build -O--buildsystem=cmake -O--builddirectory=build
	dh_auto_build -O--buildsystem=cmake -O--builddirectory=build-winuae

override_dh_install:
	dh_install --sourcedir=build

	# Install WinUAE version of hatari binary
	# Rename file
	mv build-winuae/src/hatari build-winuae/src/hatari-winuae
	dh_install --sourcedir=build-winuae src/hatari-winuae /usr/bin

	# Remove bundled EmuTOS image
	#-rm debian/hatari/usr/share/hatari/tos.img

	# Install binfmt support for atari binaries
	install -m644 -D debian/binfmt debian/hatari/usr/share/binfmts/hatari

override_dh_installman:
	dh_installman
	dh_installman debian/hatari-winuae.1

override_dh_auto_clean:
	dh_auto_clean -O--buildsystem=cmake -O--builddir=build
	dh_auto_clean -O--buildsystem=cmake -O--builddirectory=build-winuae
	find . -name *.pyc -exec rm -f {} \;

=== debian/watch ===
version=3
        opts=dversionmangle=s/\+dfsg//,uversionmangle=s/(.*)/$1+dfsg/ \
        http://download.tuxfamily.org/hatari/(\d\.\d\.\d)/hatari-(.*).tar.bz2

## hatari 2.1.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,4 @@
-
-cmake_minimum_required(VERSION 2.6 FATAL_ERROR)
-
-if(POLICY CMP0026)
-	# Should be removed if cmake_minimum_required >= 2.8.8
-	cmake_policy(SET CMP0026 OLD)
-endif(POLICY CMP0026)
+cmake_minimum_required(VERSION 2.8.8 FATAL_ERROR)
 
 project(Hatari C)
 
@@ -70,7 +64,7 @@
 
 if(APPLE)
 	set(ENABLE_OSX_BUNDLE 1
-	    CACHE BOOL "Built Hatari as Mac OS X application bundle")
+	    CACHE BOOL "Built Hatari as macOS application bundle")
 	# set(CMAKE_OSX_ARCHITECTURES "i386" CACHE STRING "Target architectures" FORCE)
 	# set(CMAKE_OSX_SYSROOT "/Developer/SDKs/MacOSX10.6.sdk" CACHE STRING "10.6 SDK" FORCE)
 	# set(CMAKE_OSX_DEPLOYMENT_TARGET "10.5" CACHE STRING "Target Min 10.5" FORCE)
@@ -78,7 +72,7 @@
 	set_source_files_properties(${FRAMEWORKS} PROPERTIES MACOSX_PACKAGE_LOCATION Frameworks)
 else()
 	set(ENABLE_OSX_BUNDLE 0
-	    CACHE BOOL "Built Hatari as Mac OS X application bundle")
+	    CACHE BOOL "Built Hatari as macOS application bundle")
 endif(APPLE)
 
 # ####################
@@ -131,6 +125,11 @@
 if(PORTAUDIO_FOUND)
 	set(HAVE_PORTAUDIO 1)
 endif(PORTAUDIO_FOUND)
+
+find_package(PortMidi)
+if(PORTMIDI_FOUND)
+	set(HAVE_PORTMIDI 1)
+endif(PORTMIDI_FOUND)
 
 find_package(CapsImage)
 if(CAPSIMAGE_FOUND)
@@ -224,14 +223,14 @@
 endif(ENABLE_MUDFLAP)
 
 # Warning flags:
-if(CMAKE_COMPILER_IS_GNUCC)
+if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcast-qual -Wbad-function-cast -Wpointer-arith")
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes -Wstrict-prototypes")
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wwrite-strings -Wsign-compare")
 	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wextra -Wno-unused-parameter -Wno-empty-body")
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat-security")
 	#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow -D_FORTIFY_SOURCE=2 -Werror")
-endif(CMAKE_COMPILER_IS_GNUCC)
+endif()
 
 # Building Hatari w/o optimization is no fun...
 IF (CMAKE_BUILD_TYPE STREQUAL "Debug")
@@ -358,6 +357,12 @@
   message( "  - portaudio :\tnot found, install it to enable the Falcon microphone input" )
 endif(PORTAUDIO_FOUND)
 
+if(PORTMIDI_FOUND)
+  message( "  - portmidi :\tfound, required for (non-Linux) MIDI support" )
+else()
+  message( "  - portmidi :\tnot found, install it for MIDI support on Windows / OSX" )
+endif(PORTMIDI_FOUND)
+
 if(CAPSIMAGE_FOUND)
   message( "  - capsimage :\tv${CAPSIMAGE_VERSION} found, allow to use .IPF, .RAW and .CTR disk images" )
 else()

=== doc/CMakeLists.txt ===

INSTALL(FILES authors.txt emutos.txt keymap-sample.txt memory-usage.txt
	midi-linux.txt release-notes.txt todo.txt
	DESTINATION ${DOCDIR})

INSTALL(FILES compatibility.html  manual.html
	DESTINATION ${DOCDIR})

INSTALL(DIRECTORY images
	DESTINATION ${DOCDIR})

if(NOT WIN32)
	add_custom_target(manpages ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/hatari.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/hatari.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/hatari.1 > ${CMAKE_CURRENT_BINARY_DIR}/hatari.1.gz
		DEPENDS hatari.1)
	INSTALL(FILES  ${CMAKE_CURRENT_BINARY_DIR}/hatari.1.gz DESTINATION ${MANDIR})
endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,23 +9,23 @@
 	paths.c  psg.c printer.c resolution.c rs232.c reset.c rtc.c
 	scandir.c stMemory.c screen.c screenConvert.c screenSnapShot.c
 	shortcut.c sound.c spec512.c statusbar.c str.c tos.c utils.c
-	vdi.c video.c wavFormat.c xbios.c ymFormat.c)
+	vdi.c inffile.c video.c wavFormat.c xbios.c ymFormat.c)
 
 # Disk image code is shared with the hmsa tool, so we put it into a library:
 add_library(Floppy createBlankImage.c dim.c msa.c st.c zip.c)
 
-# When building for OSX, define specific sources for gui and ressources
+# When building for macOS, define specific sources for gui and ressources
 if(ENABLE_OSX_BUNDLE)
 	set(GUIOSX_SOURCES
 	    gui-osx/AlertHooks.m gui-osx/PrefsController.m gui-osx/Shared.m
 	    gui-osx/CreateFloppyController.m gui-osx/SDLMain.m)
 	set_source_files_properties(${GUIOSX_SOURCES} PROPERTIES LANGUAGE C)
 	set(GUIOSX_RSRCS
-	    gui-osx/Hatari.icns gui-osx/en.lproj gui-osx/fr.lproj)
+	    gui-osx/Hatari.icns gui-osx/stdisk.png gui-osx/en.lproj gui-osx/fr.lproj)
 	set(GUIOSX_DOCS
 	    ${CMAKE_SOURCE_DIR}/doc/manual.html ${CMAKE_SOURCE_DIR}/doc/images
-	    ${CMAKE_SOURCE_DIR}/doc/compatibility.html)
-	# these are the OS X Interface Builder Files
+	    ${CMAKE_SOURCE_DIR}/doc/compatibility.html ${CMAKE_SOURCE_DIR}/doc/toc.js )
+	# these are the macOS Interface Builder Files
 	set (HATARI_XIBS en.lproj/SDLMain fr.lproj/SDLMain)
 endif(ENABLE_OSX_BUNDLE)
 
@@ -43,8 +43,8 @@
 	set(CPUDIR uae-cpu)
 endif(ENABLE_WINUAE_CPU)
 
-include_directories(${CMAKE_BINARY_DIR} ${SDL_INCLUDE_DIR} ${CPUDIR}
-		    includes debug falcon)
+include_directories(includes debug falcon
+		    ${CMAKE_BINARY_DIR} ${SDL_INCLUDE_DIR} ${CPUDIR})
 
 if(ZLIB_FOUND)
 	include_directories(${ZLIB_INCLUDE_DIR})
@@ -70,7 +70,7 @@
 add_subdirectory(gui-sdl)
 add_subdirectory(${CPUDIR})
 
-# When building for OSX, add specific sources
+# When building for macOS, add specific sources
 if(ENABLE_OSX_BUNDLE)
 	#find_library(SDL_FRAMEWORK SDL ${ADD_FRAMEWOK_PATH})
 	set(ADDITIONAL_INCLUDES ${FRAMEWORKS})
@@ -91,18 +91,18 @@
 			COMMAND mkdir -p ${BUNDLE_CONTENTS}/MacOS
 			COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${MACOSX_BUNDLE_ICON_FILE}
 				   ${BUNDLE_CONTENTS}/Resources/${MACOSX_BUNDLE_ICON_FILE}
-			# Copy Localized .nib to Bundle
+			# Copy Localized .nib and help to Bundle
 			COMMAND cp -R ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/*.lproj ${BUNDLE_CONTENTS}/Resources/
-			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/en.lproj/HatariHelp
-			COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/en.lproj/HatariHelp/
-			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/fr.lproj/HatariHelp
-			COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/fr.lproj/HatariHelp/
+			COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/HatariHelp
+			COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/HatariHelp/
+			#COMMAND mkdir -p ${BUNDLE_CONTENTS}/Resources/fr.lproj/HatariHelp
+			#COMMAND cp -R ${GUIOSX_DOCS} ${BUNDLE_CONTENTS}/Resources/fr.lproj/HatariHelp/
 	)
 	add_dependencies(hatari osx_bundle_dirs)
 	set_source_files_properties(${GUIOSX_RSRCS} PROPERTIES
 				    MACOSX_PACKAGE_LOCATION Resources)
 	set_source_files_properties(${GUIOSX_DOCS} PROPERTIES
-				    MACOSX_PACKAGE_LOCATION Resources/en.lproj/HatariHelp)
+				    MACOSX_PACKAGE_LOCATION Resources/HatariHelp)
 
 	#find ibtool
 	find_program(IBTOOL ibtool HINTS "/usr/bin" "${OSX_DEVELOPER_ROOT}/usr/bin")
@@ -116,6 +116,7 @@
 		add_custom_command (TARGET hatari POST_BUILD
 			COMMAND ${IBTOOL} --errors --warnings --notices --output-format human-readable-text
 				--compile ${BUNDLE_CONTENTS}/Resources/${xib}.nib ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${xib}.xib
+			COMMAND rm ${BUNDLE_CONTENTS}/Resources/${xib}.xib
 			COMMENT "Compiling ${CMAKE_CURRENT_SOURCE_DIR}/gui-osx/${xib}.xib")
 	endforeach()
 
@@ -165,6 +166,10 @@
 	target_link_libraries(hatari ${PORTAUDIO_LIBRARY})
 endif(PORTAUDIO_FOUND)
 
+if(PORTMIDI_FOUND)
+	target_link_libraries(hatari ${PORTMIDI_LIBRARY})
+endif(PORTMIDI_FOUND)
+
 if(CAPSIMAGE_FOUND)
 	target_link_libraries(hatari ${CAPSIMAGE_LIBRARY})
 endif(CAPSIMAGE_FOUND)

=== tools/CMakeLists.txt ===

add_subdirectory(hmsa)

include(FindPythonInterp)
if(PYTHONINTERP_FOUND)
	add_subdirectory(hconsole)
	add_subdirectory(debugger)
endif(PYTHONINTERP_FOUND)

install(PROGRAMS atari-convert-dir.py DESTINATION ${BINDIR} RENAME atari-convert-dir)
install(PROGRAMS atari-hd-image.sh DESTINATION ${BINDIR} RENAME atari-hd-image)
install(PROGRAMS zip2st.sh DESTINATION ${BINDIR} RENAME zip2st)

if(NOT WIN32)
	add_custom_target(atari_convert_dir_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/atari-convert-dir.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/atari-convert-dir.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/atari-convert-dir.1 > ${CMAKE_CURRENT_BINARY_DIR}/atari-convert-dir.1.gz
		DEPENDS atari-convert-dir.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/atari-convert-dir.1.gz DESTINATION ${MANDIR})

	add_custom_target(atari_hd_image_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/atari-hd-image.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/atari-hd-image.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/atari-hd-image.1 > ${CMAKE_CURRENT_BINARY_DIR}/atari-hd-image.1.gz
		DEPENDS atari-hd-image.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/atari-hd-image.1.gz DESTINATION ${MANDIR})

	add_custom_target(zip2st_man ALL DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/zip2st.1.gz)
	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/zip2st.1.gz
		COMMAND gzip -c -9 ${CMAKE_CURRENT_SOURCE_DIR}/zip2st.1 > ${CMAKE_CURRENT_BINARY_DIR}/zip2st.1.gz
		DEPENDS zip2st.1)
	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/zip2st.1.gz DESTINATION ${MANDIR})
endif()

=== src/cpu/CMakeLists.txt ===

include_directories(. ../.. ../includes ${SDL_INCLUDE_DIR} softfloat)

# The sources generated by gencpu:
set(CPUEMU_SRCS cpustbl.c cpuemu_0.c cpuemu_11.c cpuemu_13.c
		cpuemu_20.c cpuemu_21.c cpuemu_22.c cpuemu_23.c cpuemu_24.c
		cpuemu_31.c cpuemu_32.c cpuemu_33.c cpuemu_34.c cpuemu_35.c
		cpuemu_40.c cpuemu_50.c)

# Sources that are synchronized with WinUAE:
set(WINUAE_SRCS cpudefs.c cpummu.c cpummu030.c debug.c newcpu_common.c newcpu.c
		readcpu.c writelog.c fpp.c fpp_native.c fpp_softfloat.c
		softfloat/softfloat.c softfloat/softfloat_decimal.c
		softfloat/softfloat_fpsp.c)

# Unfortunately we've got to specify the rules for the generated files twice,
# once for cross compiling (with calling the host cc directly) and once
# for native compiling so that the rules also work for non-Unix environments...
if(CMAKE_CROSSCOMPILING)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/build68k
		COMMAND cc -I${CMAKE_CURRENT_SOURCE_DIR}
			   ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c
			   ${CMAKE_CURRENT_SOURCE_DIR}/writelog.c
			   -o ${CMAKE_CURRENT_BINARY_DIR}/build68k
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c)

	add_custom_command(OUTPUT cpudefs.c
		COMMAND ./build68k < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/table68k
			${CMAKE_CURRENT_BINARY_DIR}/build68k)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		COMMAND cc -I${CMAKE_CURRENT_SOURCE_DIR}
			   cpudefs.c ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			   ${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c
			   -o ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c cpudefs.c)

	add_custom_command(OUTPUT ${CPUEMU_SRCS}
		COMMAND ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gencpu)

else()	# Rules for normal build follow

	add_executable(build68k build68k.c writelog.c)

	add_custom_command(OUTPUT cpudefs.c
		COMMAND build68k < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS table68k build68k)

	add_executable(gencpu gencpu.c readcpu.c cpudefs.c)

	add_custom_command(OUTPUT ${CPUEMU_SRCS} COMMAND gencpu  DEPENDS gencpu)

endif(CMAKE_CROSSCOMPILING)

if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
	# Silence some warnings for the autogenerated sources - the generated
	# cpuemu_xx.c contains a lot of warnings we don't really care about...
	set(CPUEMU_CFLAGS "-Wno-sign-compare -Wno-shadow -Wno-unused-variable")
	if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.6)
		set (CPUEMU_CFLAGS "${CPUEMU_CFLAGS} -Wno-unused-but-set-variable")
	endif()
	set_source_files_properties(${CPUEMU_SRCS}
		PROPERTIES COMPILE_FLAGS ${CPUEMU_CFLAGS})

	# For the other files, hide some harmless warnings, too (since we
	# try to keep the files in sync with WinUAE, it's hard to fix them)
	set(CPUMAIN_CFLAGS "-Wno-unused-variable -Wno-unused-function -Wno-unused-label")
	if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.6)
		set (CPUMAIN_CFLAGS "${CPUMAIN_CFLAGS} -Wno-unused-but-set-variable")
	endif()
	# The remaining warnings should be hidden for release builds:
	if (CMAKE_BUILD_TYPE STREQUAL "Release")
		set(CPUMAIN_CFLAGS "${CPUMAIN_CFLAGS} -Wno-sign-compare -Wno-bad-function-cast")
		set(CPUMAIN_CFLAGS "${CPUMAIN_CFLAGS} -Wno-missing-braces")
		if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_C_COMPILER_VERSION VERSION_GREATER 4.7)
			set(CPUMAIN_CFLAGS "${CPUMAIN_CFLAGS} -Wno-maybe-uninitialized")
		endif()
	endif()
	set_source_files_properties(${WINUAE_SRCS}
		PROPERTIES COMPILE_FLAGS ${CPUMAIN_CFLAGS})
endif()

add_library(UaeCpu ${CPUEMU_SRCS} ${WINUAE_SRCS} custom.c events.c memory.c
		   hatari-glue.c)

=== src/gui-sdl/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,9 @@
 
 include_directories(. ../.. ../debug ../includes ${SDL_INCLUDE_DIR}) 
 
-if(CMAKE_COMPILER_IS_GNUCC)
+if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
 	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-write-strings")
-endif(CMAKE_COMPILER_IS_GNUCC)
+endif()
 
 add_library(GuiSdl
 	dlgAbout.c dlgAlert.c dlgCpu.c dlgDevice.c dlgFileSelect.c dlgFloppy.c

=== src/uae-cpu/CMakeLists.txt ===

include_directories(. ../.. ../includes ${SDL_INCLUDE_DIR}) 

# Unfortunately we've got to specify the rules for the generated files twice,
# once for cross compiling (with calling the host cc directly) and once
# for native compiling so that the rules also work for non-Unix environments...
if(CMAKE_CROSSCOMPILING)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/build68k
		COMMAND cc ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c
		           -o ${CMAKE_CURRENT_BINARY_DIR}/build68k
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/build68k.c)

	add_custom_command(OUTPUT cpudefs.c
		COMMAND ./build68k < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/table68k
			${CMAKE_CURRENT_BINARY_DIR}/build68k)

	add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		COMMAND cc -I${CMAKE_CURRENT_SOURCE_DIR}
			   cpudefs.c ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			   ${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c
			   -o ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/gencpu.c
			${CMAKE_CURRENT_SOURCE_DIR}/readcpu.c cpudefs.c)

	add_custom_command(OUTPUT cpuemu.c cpustbl.c
		COMMAND ${CMAKE_CURRENT_BINARY_DIR}/gencpu
		DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/gencpu)

else()	# Rules for normal build follow

	add_executable(build68k build68k.c)

	add_custom_command(OUTPUT cpudefs.c
		COMMAND build68k < ${CMAKE_CURRENT_SOURCE_DIR}/table68k >cpudefs.c
		DEPENDS table68k build68k)

	add_executable(gencpu gencpu.c readcpu.c cpudefs.c)

	add_custom_command(OUTPUT cpuemu.c cpustbl.c COMMAND gencpu DEPENDS gencpu)

endif(CMAKE_CROSSCOMPILING)


# Generated cpuemu.c contains a lot of warnings we don't really care about...
if(CMAKE_COMPILER_IS_GNUCC)
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-sign-compare -Wno-shadow")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-variable -Wno-unused-label")
endif(CMAKE_COMPILER_IS_GNUCC)

add_library(UaeCpu
	cpudefs.c cpuemu.c cpustbl.c
	hatari-glue.c memory.c newcpu.c readcpu.c fpp.c
	)

=== debian/changelog ===
hatari (2.1.0+dfsg-1) unstable; urgency=medium

  * Drop non-free disk image from upstream tarball.
  * Import upstream version 2.1.0.
  * Drop patches included upstream.
  * Drop patches taken from upstream VCS.
  * Add 06-fix-typo-in-manpage, fixing typo in manpage.
  * Update debian/copyright, authors and years.
  * Bump Standards-Version to 4.1.3, no changes needed.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sun, 25 Feb 2018 10:17:09 +0100

hatari (2.0.0+dfsg-4) unstable; urgency=medium

  * Add missing dependency on python-gtk2. (Closes: 881961)
  * Fix upstream bugs with patches from upstream vcs (Closes: 881964)
    - 10-fix-pythonui-new-config-file-locations
    - 11-fix-pythonui-options
    - 12-fix-sdl2-window-embedding
  * Fix watch file to not report false positives.
  * Drop redundant winuae cpu variant, it is now the default.
  * Bump debhelper compatibility level to 10.
  * Use https in copyright format URL.
  * Simplify debian/copyright, group GPL-2+ copyrights together.
  * Use https URL in debian/watch.
  * Use hardening=+all to get bindnow linker flag.
  * Bump standards-version to 4.1.1, no changes needed.

 -- Teemu Hukkanen <tjhukkan@iki.fi>  Sat, 18 Nov 2017 18:02:20 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Teemu Hukkanen <tjhukkan@iki.fi>
 Build-Depends: cmake,
-               debhelper (>= 9),
+               debhelper (>= 10),
                dh-python,
                libpng-dev,
                libreadline-dev,
@@ -11,12 +11,12 @@
                portaudio19-dev,
                python,
                zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Homepage: http://hatari.tuxfamily.org/
 
 Package: hatari
 Architecture: any
-Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}, python-gtk2
 Recommends: binfmt-support
 Suggests: dosfstools, mtools, unzip
 Description: Emulator for the Atari ST, STE, TT, and Falcon computers

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS=1
include /usr/share/dpkg/buildflags.mk

LDFLAGS += -Wl,--as-needed
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ --buildsystem=cmake --builddirectory=build --with=python2

override_dh_auto_configure:
	 dh_auto_configure -O--buildsystem=cmake \
	   -O--builddirectory=build \
	   -- \
	   -DCMAKE_COLOR_MAKEFILE:BOOL=0 \
	   -DCMAKE_C_FLAGS:STRING="$(CFLAGS)" \
	   -DCMAKE_CXX_FLAGS:STRING="$(CXXFLAGS)" \
	   -DCMAKE_LINK_FLAGS:STRING="$(LDFLAGS)"

override_dh_auto_build:
	dh_auto_build -O--buildsystem=cmake -O--builddirectory=build

override_dh_install:
	dh_install --sourcedir=build

	# Remove bundled EmuTOS image
	#-rm debian/hatari/usr/share/hatari/tos.img

	# Install binfmt support for atari binaries
	install -m644 -D debian/binfmt debian/hatari/usr/share/binfmts/hatari

override_dh_auto_clean:
	dh_auto_clean -O--buildsystem=cmake -O--builddir=build
	find . -name *.pyc -exec rm -f {} \;
